Kea: isc::yang::TranslatorControlSocket Class Reference

| Kea 2.2.0

Public Member Functions | Protected Member Functions | List of all members
isc::yang::TranslatorControlSocket Class Reference

Control socket translation between YANG and JSON. More...

`#include <translator_control_socket.h>`

Inheritance diagram for isc::yang::TranslatorControlSocket:
[legend]

## Public Member Functions
| TranslatorControlSocket (sysrepo::S_Session session, const std::string &model)
| Constructor. More...
virtual | ~TranslatorControlSocket ()
| Destructor. More...
isc::data::ConstElementPtr | getControlSocket (const std::string &xpath)
| Get and translate a control socket from YANG to JSON. More...
void | setControlSocket (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set control socket from JSON to YANG. More...
Public Member Functions inherited from isc::yang::TranslatorBasic
| TranslatorBasic (sysrepo::S_Session session, const std::string &model)
| Constructor. More...
virtual | ~TranslatorBasic ()
| Destructor. More...
void | checkAndGetLeaf (isc::data::ElementPtr &storage, const std::string &xpath, const std::string &name)
| Retrieves an item and stores it in the specified storage. More...
void | checkAndSetLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, sr_type_t const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath. More...
void | delItem (const std::string &xpath)
| Delete basic value from YANG. More...
template<typename functor_t >
void | forAll (std::string const &xpath, functor_t f)
| Run a function for a node and all its children. More...
isc::data::ElementPtr | getItem (const std::string &xpath)
| Get and translate basic value from YANG to JSON. More...
isc::data::ElementPtr | getItems (const std::string &xpath)
| Get and translate a list of basic values from YANG to JSON. More...
template<typename T >
isc::data::ElementPtr | getList (std::string const &xpath, T &t, isc::data::ElementPtr(T::*f)(std::string const &xpath))
| Retrieve a list as ElementPtr from sysrepo from a certain xpath. More...
sysrepo::S_Vals | getValuesFromItems (std::string const &xpath)
| Get the values of all siblings at a certain xpath. More...
void | setItem (const std::string &xpath, isc::data::ConstElementPtr elem, sr_type_t type)
| Translate and set basic value from JSON to YANG. More...

## Protected Member Functions
isc::data::ElementPtr | getControlSocketKea (const std::string &xpath)
| getControlSocket JSON for kea models. More...
void | setControlSocketKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setControlSocket for kea models. More...

## Additional Inherited Members
Static Public Member Functions inherited from isc::yang::TranslatorBasic
static sysrepo::S_Val | value (isc::data::ConstElementPtr elem, sr_type_t type)
| Translate basic value from JSON to YANG. More...
static isc::data::ElementPtr | value (sysrepo::S_Val s_val)
| Translate basic value from YANG to JSON. More...
Protected Attributes inherited from isc::yang::TranslatorBasic
std::string | model_
| The model. More...
sysrepo::S_Session | session_
| The sysrepo session. More...

## Detailed Description

Control socket translation between YANG and JSON.

JSON syntax for all Kea servers with command channel is:

"control-socket": {
"socket-type": "<socket type>",
"socket-name": "<socket name>",
"user-context": { <json map> },
"comment": "<comment>"
}

YANG syntax is:

+--rw control-socket!
+--rw socket-name string
+--rw socket-type enumeration
+--rw user-context? user-context

An example in JSON and YANG formats:

{
"socket-name": "/tmp/kea.sock",
"socket-type": "unix",
"user-context": { "foo": 1 }
}
/kea-ctrl-agent:config (container)
/kea-ctrl-agent:config/control-sockets (container)
/kea-ctrl-agent:config/control-sockets/
socket[server-type='dhcp4'] (list instance)
/kea-ctrl-agent:config/control-sockets/socket[server-type='dhcp4']/
server-type = dhcp4
/kea-ctrl-agent:config/control-sockets/socket[server-type='dhcp4']/
control-socket (container)
/kea-ctrl-agent:config/control-sockets/socket[server-type='dhcp4']/
control-socket/socket-name = /tmp/kea.sock
/kea-ctrl-agent:config/control-sockets/socket[server-type='dhcp4']/
control-socket/socket-type = unix
/kea-ctrl-agent:config/control-sockets/socket[server-type='dhcp4']/
control-socket/user-context = { \"foo\": 1 }

A translator class for converting a control socket between YANG and JSON.

Supports the following models:

- kea-dhcp4-server
- kea-dhcp6-server
- kea-dhcp-ddns
- kea-ctrl-agent

Definition at line 69 of file translator_control_socket.h.

## Constructor & Destructor Documentation

## ◆ TranslatorControlSocket()

isc::yang::TranslatorControlSocket::TranslatorControlSocket | ( | sysrepo::S_Session | session,
|  | const std::string & | model
| ) |  |

Constructor.

Parameters

  session | Sysrepo session.
  model | Model name.

Definition at line 21 of file translator_control_socket.cc.

## ◆ ~TranslatorControlSocket()

isc::yang::TranslatorControlSocket::~TranslatorControlSocket | ( |  | ) |
| virtual

Destructor.

Definition at line 26 of file translator_control_socket.cc.

## Member Function Documentation

## ◆ getControlSocket()

ConstElementPtr isc::yang::TranslatorControlSocket::getControlSocket | ( | const std::string & | xpath | ) |

Get and translate a control socket from YANG to JSON.

Parameters

  xpath | The xpath of the control socket.

Returns
  JSON representation of the control socket or null.

Exceptions

  SysrepoError | when sysrepo raises an error.

Definition at line 30 of file translator_control_socket.cc.

References getControlSocketKea(), isc_throw, isc::yang::TranslatorBasic::model_, and isc::Exception::what().

Referenced by isc::yang::TranslatorConfig::getServerKeaDhcpCommon().

Here is the call graph for this function:

## ◆ getControlSocketKea()

ElementPtr isc::yang::TranslatorControlSocket::getControlSocketKea | ( | const std::string & | xpath | ) |
| protected

getControlSocket JSON for kea models.

Parameters

  xpath | The xpath of the control socket.

Returns
  JSON representation of the control socket.

Exceptions

  SysrepoError | when sysrepo raises an error.

Definition at line 48 of file translator_control_socket.cc.

References isc::yang::TranslatorBasic::getItem().

Referenced by getControlSocket().

Here is the call graph for this function:

## ◆ setControlSocket()

void isc::yang::TranslatorControlSocket::setControlSocket | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem
| ) |  |

Translate and set control socket from JSON to YANG.

Parameters

  xpath | The xpath of the control socket.
  elem | The JSON element.

Definition at line 66 of file translator_control_socket.cc.

References isc_throw, isc::yang::TranslatorBasic::model_, setControlSocketKea(), and isc::Exception::what().

Referenced by isc::yang::TranslatorConfig::setServerKeaDhcpCommon().

Here is the call graph for this function:

## ◆ setControlSocketKea()

void isc::yang::TranslatorControlSocket::setControlSocketKea | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem
| ) |  |
| protected

setControlSocket for kea models.

Null elem argument removes the container. Required parameters passed in elem are: socket-name, socket-type. Optional parameters are: user-context.

Parameters

  xpath | The xpath of the control socket.
  elem | The JSON element.

Exceptions

  BadValue | on control socket without socket type or name.

Definition at line 87 of file translator_control_socket.cc.

References isc::yang::TranslatorBasic::delItem(), isc::yang::Adaptor::getContext(), isc_throw, and isc::yang::TranslatorBasic::setItem().

Referenced by setControlSocket().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- translator_control_socket.h
- translator_control_socket.cc